<template>
  <div class="d-none d-sm-inline-block">
    <div class="subheader mb-2">Search in</div>
    <div class="mb-3">
      <b-form-checkbox
        v-for="field in searchFieldObjects"
        :key="field.index"
        v-model="field.checked"
        class="mb-2"
        @change="toggleCheck(field)"
      >
        {{ field.name }}
      </b-form-checkbox>
      <b-form-checkbox
        v-model="allChecked"
        class="mb-2"
        @change="toggleCheckAll"
      >
        All
      </b-form-checkbox>
    </div>
    <div class="subheader mb-2">Order by</div>
    <div class="mb-3">
      <b-form-radio
        v-for="field in sortFields"
        :key="field.index"
        v-model="order"
        class="mb-2"
        name="form-order-by"
        :value="field.filterBy"
        @change="emitChanges"
      >
        {{ field.text }}
      </b-form-radio>
    </div>
    <div class="subheader mb-2">Direction</div>
    <div class="mb-2">
      <b-form-radio
        v-for="option in directions.options"
        :key="option.index"
        v-model="directions.selected"
        class="mb-2"
        name="form-direction"
        :value="option"
        @change="emitChanges"
      >
        {{ option }}
      </b-form-radio>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    searchFields: {
      type: Array,
      default: () => [],
    },
    sortFields: {
      type: Array,
      default: () => [],
    },
    direction: {
      type: String,
      default: 'Ascending',
    },
  },
  data() {
    const order = this.sortFields[0].filterBy;
    const directions = {
      options: ['Ascending', 'Descending'],
      selected: this.direction,
    };
    return {
      searchFieldObjects: this.searchFields.map((fieldName) => {
        return {
          name: fieldName.text,
          filterBy: fieldName.filterBy,
          checked: true,
        };
      }),
      allChecked: true,
      order,
      directions,
    };
  },
  methods: {
    toggleCheckAll() {
      this.searchFieldObjects.forEach((field) => {
        field.checked = this.allChecked;
      });
      this.emitChanges();
    },
    toggleCheck(field) {
      if (field.checked) {
        this.allChecked = this.searchFieldObjects.reduce((prev, current) => {
          return prev && current.checked;
        }, true);
      } else {
        this.allChecked = false;
      }
      this.emitChanges();
    },
    emitChanges() {
      const newFilters = {
        filterBy: this.searchFieldObjects.filter(
          (field) => field.checked === true
        ),
        orderBy: this.order,
        direction: this.directions.selected,
      };
      this.$emit('filtersChanged', newFilters);
    },
  },
};
</script>
